#include "CommonThread.h"

CommonThread::CommonThread(SimpleQueuePtr queue) {
	this->queue = queue;
}

CommonThread::~CommonThread() {
}

void CommonThread::run() {
	ElementPtr elem;
	
	cout << "Thread" << this << " is running." << endl;
	while(elem = queue->pop())
	{
	for(int i=0; i< 5000; i++) { /*no op*/} 
	
	queue->threadMutex.enterMutex();
	
	if(elem) { 
		cout << this <<": got element #" << elem->getString() << endl;
	}	

	queue->threadMutex.leaveMutex();
	}

	cout << "Thread" << this << " is terminating..." << endl;
}

int main( void ) {
	// Used for queue to call threads
	vector<ThreadPtr> threadList;
	
	SimpleQueuePtr queue = SimpleQueuePtr(new SimpleQueue());

	for(int i = 0; i < 10; i++) {
	    ThreadPtr ptr(new CommonThread(queue));
	    ptr->start();
	    threadList.push_back(ptr);
	}
		
	sleep(10);
	return 0;
}
